.text
__trapHandler:
	lw	$k0, 8($0)	# process reg save area ptr is at Mem[8]
	sw	$at, 4($k0)
	sw	$v0, 8($k0)
	sw	$v1, 12($k0)
	sw	$a0, 16($k0)
	sw	$a1, 20($k0)
	sw	$a2, 24($k0)
	sw	$a3, 28($k0)
	sw	$t0, 32($k0)
	sw	$t1, 36($k0)
	sw	$t2, 40($k0)
	sw	$t3, 44($k0)
	sw	$t4, 48($k0)
	sw	$t5, 52($k0)
	sw	$t6, 56($k0)
	sw	$t7, 60($k0)
	sw	$s0, 64($k0)
	sw	$s1, 68($k0)
	sw	$s2, 72($k0)
	sw	$s3, 76($k0)
	sw	$s4, 80($k0)
	sw	$s5, 84($k0)
	sw	$s6, 88($k0)
	sw	$s7, 92($k0)
	sw	$t8, 96($k0)
	sw	$t9, 100($k0)
	sw	$gp, 112($k0)
	sw	$sp, 116($k0)
	sw	$fp, 120($k0)
	sw	$ra, 124($k0)

	lw	$gp, 0($0)	# kernel gp is at Mem[0]
	lw	$sp, 4($0)	# kernel sp is at Mem[4]
	j	exceptionHandler
	
# __init(int osSize) -- called by bootloader to start os
__init:
	sw	$gp, 0($0)	        # we save the kernel $gp at Mem[0]
	sw	$sp, 4($0)	        # ... and the $sp at Mem[4]
	addi	$t0, $0, 0x18           # get trap handler address
	addi	$sp, $sp, -4		# top of stack has osSize now
	sw	$t0, 0($sp)		# add trap handler address
	j	init			# and call init()

# restore process registers and go...
__dispatch:
	lw	$k0, 0($sp)             # addr of saved reg array
	sw	$k0, 8($0)		# save it for use in __trapHandler
	lw	$at, 4($k0)
	lw	$v0, 8($k0)
	lw	$v1, 12($k0)
	lw	$a0, 16($k0)
	lw	$a1, 20($k0)
	lw	$a2, 24($k0)
	lw	$a3, 28($k0)
	lw	$t0, 32($k0)
	lw	$t1, 36($k0)
	lw	$t2, 40($k0)
	lw	$t3, 44($k0)
	lw	$t4, 48($k0)
	lw	$t5, 52($k0)
	lw	$t6, 56($k0)
	lw	$t7, 60($k0)
	lw	$s0, 64($k0)
	lw	$s1, 68($k0)
	lw	$s2, 72($k0)
	lw	$s3, 76($k0)
	lw	$s4, 80($k0)
	lw	$s5, 84($k0)
	lw	$s6, 88($k0)
	lw	$s7, 92($k0)
	lw	$t8, 96($k0)
	lw	$t9, 100($k0)
	lw	$gp, 112($k0)
	lw	$sp, 116($k0)
	lw	$fp, 120($k0)
	lw	$ra, 124($k0)
	rfe
	
switchTo:
	sw	$ra, 0($0)		# save our state
	sw	$sp, 4($0)
	sw	$fp, 8($0)
	sw	$gp, 12($0)
	sw	$ra, 16($0)
	lw	$t0, 0($sp)		# get ptr to process structure
	lw	$sp, 0($t0)		# old sp: DON'T USE $SP
	lw	$fp, 4($t0)
	lw	$gp, 8($t0)
	lw	$t1, 12($t0)            # PC
	mtc0	$14, $t1
	lw	$t1, 16($t0)		# Base
	mtc0	$0, $t1
	lw	$t1, 20($t0)		# length
	mtc0	$1, $t1
	rfe
